import React, { useEffect, useState, useRef, useMemo } from 'react';
import axios from 'axios';
var AB_TEST_URL = 'http://localhost:3001/v1/visit/ab/';
var AB_TEST_VIEW_DURATION_URL = 'http://localhost:3001/v1/visit/ab/view/duration';
var AB_TEST_EVENT = 'http://localhost:3001/v1/visit/ab/add/event';
var AB_TEST_CONVERSION = 'http://localhost:3001/v1/visit/ab/update/conversion';
var TestAB = function (props) {
    console.log('TestAB');
    // Listening to viewport changes
    var refDiv = useRef(null);
    var EmptyComponent = function () {
        return React.createElement(React.Fragment, null, "Loading ...");
    };
    var isInViewport1 = useIsInViewport(refDiv);
    function useIsInViewport(ref) {
        var _a = useState(false), isIntersecting = _a[0], setIsIntersecting = _a[1];
        var observer = useMemo(function () {
            return new IntersectionObserver(function (_a) {
                var entry = _a[0];
                return setIsIntersecting(entry.isIntersecting);
            });
        }, []);
        useEffect(function () {
            // eslint-disable-next-line @typescript-eslint/ban-ts-comment
            // @ts-ignore
            observer.observe(ref.current);
            return function () {
                observer.disconnect();
            };
        }, [ref, observer]);
        return isIntersecting;
    }
    // Update view duration if the component is in viewport
    useEffect(function () {
        var interval = setInterval(function () {
            var isBrowserActive = ((typeof document.hasFocus != 'undefined' ? document.hasFocus() : 1) ? 1 : 0);
            if (isInViewport1 && isBrowserActive) {
                // Update view duration
                axios.get(AB_TEST_VIEW_DURATION_URL, { withCredentials: true });
            }
        }, 1000);
        return function () { return clearInterval(interval); };
    }, [isInViewport1]);
    var _a = useState(null), selectedComponent = _a[0], setSelectedComponent = _a[1];
    useEffect(function () {
        axios.get("".concat(AB_TEST_URL).concat(props.id), { withCredentials: true })
            .then(function (res) {
            console.log(res.data);
            setSelectedComponent(res.data.component);
        })["catch"](function (error) {
            console.error(error.response);
            setSelectedComponent(0);
        });
    }, [props.id]);
    // Collection click data
    var clickOnDiv = function () {
        axios.post(AB_TEST_EVENT, {
            event: 'clicked'
        }, { withCredentials: true });
    };
    return React.createElement("div", { ref: refDiv, onClick: clickOnDiv }, selectedComponent !== null ? React.createElement(props.components[selectedComponent]) : React.createElement(EmptyComponent, null));
};
// Custom event sending
var Event = {
    send: function (name) {
        if (name) {
            axios.post(AB_TEST_EVENT, {
                event: name
            }, { withCredentials: true });
        }
        else {
            console.error('Event name can\'t be empty!');
        }
    }
};
// Update conversion status
var Conversion = {
    update: function (status) {
        if (typeof status == 'boolean') {
            axios.post(AB_TEST_CONVERSION, {
                status: status
            }, { withCredentials: true });
        }
        else {
            console.error('Conversion only accept true/false!');
        }
    }
};
export default TestAB;
export { Event, Conversion };
//# sourceMappingURL=index.js.map